/***** 	
	from CTRACE: A MESSAGE LOGGING CLASS
	by William D. Cramer in Dr. Dobbs Journal #170, p. 44-55, 116-120.
*****/

/** CLogPanarama.h -- Definitions for using the LogPanorama class **/
#define _H_CLogPanorama

/* System/library headers */
#include <CPanorama.h>		/* definitions for superclass Panorama */
#include <CScrollPane.h>	/* definitions for ScrollPane class */
#include <CWindow.h>		/* definitions for Window class */
#include <oops.h>		/* standard OOP definitions */
#include <Constants.h>		/* miscellaneous look-n-feel paramaters */
#include <Limits.h>		/* numeric extrema */

/* Local headers */
#include "CLogList.h"		/* definitions for LogList class */

#define LOGPANE_FONT	(monaco)    /* font family of text in the log window */
#define LOGPANE_FONT_SIZE	(9) /* size of text in the log window */
#define LOGPANE_HORZ_SCROLL	(5) /* units per horizontal scroll */
#define LOGPANE_VERT_SCROLL	(1) /* units per vertical scroll */
#define LOGPANE_INSET		(4) /* left margin for start of text */

/* Externals referenced */
extern RgnHandle	gUtilRgn;		    	/* drawing region */

struct CLogPanorama : CPanorama
{
	/* local class instance data */
	CLogList	*itsLogList;	/* the buffer for logged data */
	/* local class methods */
	void	ILogPane (short records, CBureaucrat *aSupervisor, CWindow *anEnclosure);
	void	AddString (char *theString);
	/* inherited methods overriden */
	void	Draw (Rect *theRect);
};
