/************************************************************************************/
/*	ColorCheck																		*/
/*																					*/
/*	Set the global variable useColor, which will be used to determine whether to	*/
/*	use color icons, windows, dialogs, etc.											*/
/*																					*/
/*	Thanks to Mark Jaffee for suggesting the two tests for machine types and color	*/
/*	QuickDraw before the call to GetMainDevice.  The additional tests enable this	*/
/*	routine to properly return a FALSE result for older machines like the Mac Plus.	*/
/*																					*/
/************************************************************************************/

#include "MyHeaders.h"

Boolean ColorCheck()
{
	short			CCRetCode = FALSE;					/* set return code				*/
	GDHandle	theGD;								/* handle to the graf dev rec	*/
	SysEnvRec	gMac;

	
	useColor = FALSE;								/* default to don't use			*/
	
	SysEnvirons(1, &gMac);
	if ((gMac.machineType > 0) && gMac.hasColorQD)			/* if not old Mac 		*/
		{													/* get graph device rec	*/
		theGD = GetMainDevice();							/*  for the main screen	*/
		useColor = TestDeviceAttribute (theGD, gdDevType);	/* test for color mnitr	*/
		}


ENDING:
	CCRetCode = useColor;
	return CCRetCode;
}
