	/* Miscellaneous definitions */

/* #define TEST_MODE */

#define NIL 0L
#define MINUS_ONE -1L
#define HASH_SIZE 50
#define	NAME_SIZE 32
#define	LONG_NAME_SIZE 256

	/* Resource definitions */

enum {
	APPLE_MENU = 1,
	FILE_MENU,
	EDIT_MENU
};

enum {
	APPLE_ABOUT = 1,
	FILE_OPTIONS = 1,
	FILE_PROCESS,
	FILE_CLOSE,
	FILE_QUIT
};

#define STR_ID 200

enum {
	/* String 1 is reserved... */
	STR_NODESK = 2,
	STR_FINDERID,
	STR_BADFINDERID,
	STR_READDESKTOP,
	STR_READDISK,
	STR_READFOLDER,
	STR_UPDATEDESKTOP,
	STR_COMMENT,
	STR_COMMENTS,
	STR_BUNDLE,
	STR_BUNDLES,
	STR_APPL,
	STR_APPLS,
	STR_DESKTOP
};

#define MBAR_RESOURCE 200

enum {
	DIALOG_ABOUT = 200,
	DIALOG_VOLUME,
	DIALOG_PROCESS,
	DIALOG_OPTIONS,
	DIALOG_STATS
};

enum {
	ALERT_ROM = 200,
	ALERT_GENERAL,
	ALERT_OPTIONS
};

	/* Global variables. */

#ifdef FIX_MAIN
int is_hfs, volume_refnum,
	process_comments = 1, process_bundles = 1, process_appls = 0;
int comment_count, bndl_count, appl_count;
unsigned char string[LONG_NAME_SIZE];
#else
extern int is_hfs, volume_refnum,
		   process_comments, process_bundles, process_appls;
extern int comment_count, bndl_count, appl_count;
extern unsigned char string[LONG_NAME_SIZE];
#endif

	/* Global prototypes. */

	/* applications.c */

void pre_appl_processing(void);
void post_appl_processing(void);
void add_application(long type, int dir_id, unsigned char *name);

	/* bundles.c */

void pre_bundle_processing(void);
void post_bundle_processing(void);
void remove_bndl(long type);

	/* comments.c */

void pre_comment_processing(void);
void post_comment_processing(void);
void remove_fcmt(int number);
int comment_hash(unsigned char *name);

	/* hfs.c */

void hfs_scan_disk(void);

	/* mfs.c */

void mfs_scan_disk(void);

	/* options.c */

void do_options(void);

	/* process.c */

void one_pass(void);
void set_processing(unsigned char *name);

	/* utility.c */

void set_watch_cursor(void);
void set_normal_cursor(void);
void kill_resource(long type, int id);
#ifdef _DialogMgr_
Handle get_item(DialogPtr the_dialog, int item);
#endif
void copystr(unsigned char *dest, unsigned char *source);
void concatstr(unsigned char *first, unsigned char *second, unsigned char *dest);
int equalstr(unsigned char *s1, unsigned char *s2);		/* 1  => equal */

	/* volume.c */

int select_volume_dialog(int *refnum, int *is_hfs);
