/*	CMIDI - my interface class for the MIDI Manager. Includes Anodyne-specific
			stuff (like instrument bulk dump capture and so on). */

#define _H_CMIDI

#include <MidiManager.h>		/*	For "MIDIPacketPtr". */
#include "CInstrument.h"

struct CMIDI: CObject {
	NEW			void	IMIDI(Boolean pollingVersion);
	OVERRIDE	void	Dispose(void);

	NEW			void	StatusCheck(void);
	NEW			void	Pause(int msec);
	PRIVATE		void	Dispatch(RouteRec route, MIDIPacketPtr p, Byte cont);
	PRIVATE		void	Transmit(RouteRec route, Byte *mesg,
								 long len, Boolean showStatus
								);
	NEW			void	Silence(void);
	NEW			void	SetOutput(RouteRec route);
	NEW			void	ClearOutput(void);
	NEW			void	StartEchoing(RouteRec route);
	NEW			void	StopEchoing(void);
	NEW			void	PatchChange(int patch);
	PRIVATE		long	CalcSysExLength(Byte *mesg);
	NEW			void	SendSysEx(Byte *mesg, Boolean showStatus);
	NEW			void	InitiateCapture(CInstrument *instrument);
	NEW			void	CancelCapture(void);
	PRIVATE		void	CoolOff(void);
	NEW			Boolean	Unloading(void);
	PRIVATE		void	CheckConnect(OSErr err);
	PRIVATE		void	PatchMeIn(void);
};

extern CMIDI *gMIDI;
