/******************************************************************************
	Based on files that are:
	COPYRIGHT (C) 1984-1990 Apple Computer,Inc.
	All rights reserved
	
	Interface for ResEdit 2.1
	
	Modifications for THINK C 4.0, 4.02 by Maarten Meijer.
	
    Some modifications by Erik A. Johnson (johnsone@uxh.cso.uiuc.edu) for
    THINK C (5.0.1).

	CIS 100016,1764; FidoNet 2:512/114
*******************************************************************************/
/*
	Please note that the resource name has to be preceded by a zero byte:
	"\000ICON", use Clipboard magician to achieve this effect in THINK C
*/

/* This is the standard interface for a Resource Standard Code segment for use
 by the resource editor.  The main resource editor will dispatch to this code
 when the user opens the respective type for editing.  Dispatches will also
 occur with menu commands and events for this window.  This code should be
 included in the resource editor file under type RSSC with any unique ID.  It's
 resource name should consist of the type it's willing to edit or 'ALL' if it
 can edit all types of resources. {This comment is too old...}
*/

/* Each code segment MUST have a window and its kind MUST be the ID of the
 code and the refcon usually contains the handle to the instance of the object
 who's owned by the code.  On activate/deactivate events, the code can put up
 and remove any menus if desired.
*/

/* The standard routines are:
*/
#include <asm.h>
#include <ResEd.h>

/*
		Implemented in pascal for now...
	    EditBirth( thing:Handle; parent: ParentHandle );
	    PickBirth( t: ResType; parent: ParentHandle );
	    DoMenu( menu, item: INTEGER; object: Handle );
	    DoEvent( VAR evt: EvtRecord; object: Handle );
*/

#ifdef THINK_C
pascal void EditBirth(Handle thing, ParentHandle dad);
pascal void PickBirth(ResType t, ParentHandle dad);
pascal void DoEvent(EventRecord *evt, PickHandle pick);
pascal void DoInfoUpdate(short oldID, short newID, PickHandle pick);
pascal void DoMenu(short menu, short item, PickHandle pick);
pascal Boolean IsThisYours (Handle thing, PickHandle pick);
#else
pascal void PickBirth();
pascal void EditBirth();
pascal void DoEvent();
pascal void DoMenu();
pascal void DoInfoUpdate();
pascal Boolean IsThisYours();
#endif

pascal short ResEdID();

/*
  In the following function StdHeader the offsets are calculated by hand,
  since the THINK assembler does not allow the difference between two labels
  to be used as an operand. (See THINK C 4.0 manual p.165)
  
  Maarten Meijer, 1990 12 18
  
  This special format makes it necessary to use the Custom Headers option of TC
*/
void StdHeader(void);

void StdHeader() {
asm {
/* Address: */
/* 0x0000 */			DC.L		('RSSC')
/* 0x0004 */			DC.W		0x16	/* @JEditBirth-StdHeader */
/* 0x0006 */			DC.W		0x1A	/* @JPickBirth-StdHeader */
/* 0x0008 */			DC.W		0x1E	/* @JDoEvent-StdHeader */
/* 0x000A */			DC.W		0x22	/* @JDoMenu-StdHeader */
/* 0x000C */			DC.W		0x26	/* @JDoInfoUpdate-StdHeader */
/* 0x000E */			DC.W		0x2A	/* @JIsThisYours-StdHeader */
/* 0x0010 */			DC.W		0
/* 0x0012 */			DC.W		0
/* 0x0014 */			DC.W		0
@JEditBirth:
/* 0x0016 */			JMP			EditBirth
@JPickBirth:
/* 0x001A */			JMP			PickBirth
@JDoEvent:
/* 0x001E */			JMP			DoEvent
@JDoMenu:
/* 0x0022 */			JMP			DoMenu
@JDoInfoUpdate:
/* 0x0026 */			JMP			DoInfoUpdate
@JIsThisYours:
/* 0x002A */			JMP			IsThisYours
		}
	}

/*
	Use trick to port this assembly code
	Gets Res ID of self and returns it
	    FUNCTION ResEdID: INTEGER;
*/
static void dummy(void);

static void
dummy () {
	asm {
extern	ResEdID:
			LINK		A6,#-256

			LEA			StdHeader,A0
			_RecoverHandle

			MOVE.L      A0,-(SP)			; pass handle
			PEA			8(A6)				; function result
			PEA			-256(A6)			; ignore type
			MOVE.L      (SP),-(SP)			; ignore name
			_GetResInfo

			UNLK		A6
			RTS
			DC.B		"RESEDID "
		 }
	}

void	main() {
	Debugger();
	asm {
			RTS
			DC.B		"MAIN    "
		}
	/* not used */
	}
