/******************************************************************************
	File ResDisp.a.c	
	(original ResDisp.a  COPYRIGHT (C) 1984-1990 Apple Computer,Inc.)
	All rights reserved

	Interface for ResEdit 2.1

	Linking with this code allows Pickers, Editors or whatever to call
	certain routines in ResEdits CODE segments.
	
	Modifications for THINK C 4.0, 4.02 by Maarten Meijer.
	
    Some modifications by Erik A. Johnson (johnsone@uxh.cso.uiuc.edu) for
    THINK C (5.0.1).

	CIS 100016,1764; FidoNet 2:512/114
*******************************************************************************/

#define ApplScratch	0xa78


/* Calls back to main program */
void	DrawLDEF();
void	BubbleUp();
void	REGet1IndResource();
void	RECount1Resources();
void	UseAppRes();
void	REGet1Resource();
void	REGet1ResourceSpecial();
void	ColorAvailable();
void	GetStr();
void	GetNamedStr();
void	CallInfoUpdate();
void	PassMenu();
void	GiveSubEBirth();
void	GetQuickDrawVars();
void	NeedToRevert();
void	DisplayStrAlert();
void	DrawPopup();
void	DoPopup();
void	NoDoubleClickHere();
void	SendRebuildToPickerAndFile();
void	WindReturn();
void	WindList();
void	WindOrigin();
void	AbleMenu();
void	FindOwnerWindow();
void	BuildType();
void	GrowMyWindow();
void	ConcatStr();
void	PickStdHeight();
void	PickStdWidth();
void	ChooseIcon();
void	DupPick();
void	SysResFile();
void	RevertThisResource();
void	FixHand();
void	CallDoEvent();
void	DrawMBarLater();
void	PassEvent();
void	GiveEBirth();
void	HandleCheck();
void	MetaKeys();
void	PickEvent();
void	PickInfoUp();
void	PickMenu();
void	SendRebuildToPicker();
void	ScrapCopy();
void	ScrapEmpty();
void	ScrapPaste();
void	SetResChanged();
void	SetETitle();
void	GetResEditScrapFile();
void	FloatingWindowSetup();
void	ShowInfo();
void	GiveThisEBirth();
void	KillCache();
void	DefaultListCellSize();
void	DoKeyScan();
void	TypeToString();
void	FrameDialogItem();
void	FlashDialogItem();
void	AlreadyOpen();
void	EditorWindSetup();
void	GetWindowTitle();
void	Abort();
void	DisplayAlert();
void	WasAborted();
void	GetType();
void	CheckError();
void	CloseNoSave(); 
void	SetTheCursor();
void	RestoreRemovedResources();
void	MapResourceType();
void	WasItLoaded();
void	PickerWindSetup();
void	PrintWindow();
void	PrintSetup();
void	DoPickBirth();
void	WritePreferences();
void	GetErrorText();
void	CenterDialog();
void	PlaySyncSound();
void	ResourceIDHasChanged();
void	InstallColorPalettePopup();
void	WindAlloc();
void	DrawColorPopup();
void	ColorPalettePopupSelect();
void	DeinstallColorPalettePopup();
void	RERemoveAnyResource();
void	REAddNewRes();
void	RENewUniqueRes();
void	REBeautifulUnique1ID();
void	RECount1Types();
void	REGet1IndType();
void	REGet1NamedResource();
void	REAddResource();
void	StandardFilter();

static void	CallOut(void);
static void	DivingBoard();

static void	CallOut() {
	asm {

extern DrawLDEF:					JSR DivingBoard		/*  1 */
extern BubbleUp:					JSR DivingBoard
extern REGet1IndResource:			JSR DivingBoard
extern RECount1Resources:			JSR DivingBoard
extern UseAppRes:					JSR DivingBoard		/*  5 */
extern REGet1Resource:				JSR DivingBoard
extern REGet1ResourceSpecial:		JSR DivingBoard		/* 7 */
extern ColorAvailable:				JSR DivingBoard
extern GetStr:						JSR DivingBoard
extern GetNamedStr:					JSR DivingBoard		/* 10 */
extern BuildType:					JSR DivingBoard
extern GrowMyWindow:				JSR DivingBoard
extern ColorPalettePopupSelect:		JSR DivingBoard
extern ConcatStr:					JSR DivingBoard
extern PickStdHeight:				JSR DivingBoard
extern PickStdWidth:				JSR DivingBoard
extern ChooseIcon:					JSR DivingBoard
extern DeinstallColorPalettePopup:	JSR DivingBoard
extern DupPick:						JSR DivingBoard
extern SysResFile:					JSR DivingBoard		/* 20 */
extern RevertThisResource:			JSR DivingBoard
extern FixHand:						JSR DivingBoard
extern DrawColorPopup:				JSR DivingBoard
extern DrawMBarLater:				JSR DivingBoard			
extern CallDoEvent:					JSR DivingBoard
extern PassEvent:					JSR DivingBoard
extern GiveEBirth:					JSR DivingBoard
extern HandleCheck:					JSR DivingBoard
extern MetaKeys:					JSR DivingBoard
extern AbleMenu:					JSR DivingBoard		/* 30 */
extern PickEvent:					JSR DivingBoard
extern PickInfoUp:					JSR DivingBoard
extern PickMenu:					JSR DivingBoard
extern SendRebuildToPicker:			JSR DivingBoard
extern ScrapCopy:					JSR DivingBoard
extern ScrapEmpty:					JSR DivingBoard
extern ScrapPaste:					JSR DivingBoard
extern SetResChanged:				JSR DivingBoard
extern ShowInfo:					JSR DivingBoard
extern SetETitle:					JSR DivingBoard		/* 40 */
extern GetResEditScrapFile:			JSR DivingBoard
extern FloatingWindowSetup:			JSR DivingBoard
extern CallInfoUpdate:				JSR DivingBoard
extern PassMenu:					JSR DivingBoard
extern GiveSubEBirth:				JSR DivingBoard
extern GetQuickDrawVars:			JSR DivingBoard
extern NeedToRevert:				JSR DivingBoard
extern DisplayStrAlert:				JSR DivingBoard		/* 48 */
extern DrawPopup:					JSR DivingBoard		/* 49 */
extern GiveThisEBirth:				JSR DivingBoard		/* 50 */
extern WindReturn:					JSR DivingBoard		/* 51 */
extern KillCache:					JSR DivingBoard		/* 52 */
extern DefaultListCellSize:			JSR DivingBoard		/* 53 */
extern DoKeyScan:					JSR DivingBoard		/* 54 */
extern TypeToString:				JSR DivingBoard		/* 55 */
extern FrameDialogItem:				JSR DivingBoard		/* 56 */
extern FlashDialogItem:				JSR DivingBoard		/* 57 */
extern AlreadyOpen:					JSR DivingBoard		/* 58 */
extern EditorWindSetup:				JSR DivingBoard		/* 59 */
extern GetWindowTitle:				JSR DivingBoard		/* 60 */
extern Abort:						JSR DivingBoard		/* 61 */
extern DisplayAlert:				JSR DivingBoard		/* 62 */
extern WasAborted:					JSR DivingBoard		/* 63 */
extern GetType:						JSR DivingBoard		/* 64 */
extern CheckError:					JSR DivingBoard		/* 65 */
extern CloseNoSave:					JSR DivingBoard		/* 66 */
extern SetTheCursor:				JSR DivingBoard		/* 67 */
extern RestoreRemovedResources:		JSR DivingBoard		/* 68 */
extern MapResourceType:				JSR DivingBoard		/* 69 */
extern WasItLoaded:					JSR DivingBoard		/* 70 */
extern PickerWindSetup:				JSR DivingBoard		/* 71 */
extern WindOrigin:					JSR DivingBoard		/* 72 */
extern FindOwnerWindow:				JSR DivingBoard		/* 73 */
extern PrintWindow:					JSR DivingBoard		/* 74 */
extern PrintSetup:					JSR DivingBoard		/* 75 */
extern NoDoubleClickHere:			JSR DivingBoard		/* 76 */
extern DoPickBirth:					JSR DivingBoard		/* 77 */
extern WritePreferences:			JSR DivingBoard		/* 78 */
extern GetErrorText:				JSR DivingBoard		/* 79 */
extern CenterDialog:				JSR DivingBoard		/* 80 */
extern PlaySyncSound:				JSR DivingBoard		/* 81 */
extern ResourceIDHasChanged:		JSR DivingBoard		/* 82 */
extern RERemoveAnyResource:			JSR DivingBoard		/* 83 */
extern REAddNewRes:					JSR DivingBoard		/* 84 */
extern RENewUniqueRes:				JSR DivingBoard		/* 85 */
extern REBeautifulUnique1ID:		JSR DivingBoard		/* 86 */
extern RECount1Types:				JSR DivingBoard		/* 87 */
extern SendRebuildToPickerAndFile:	JSR DivingBoard		/* 88 */
extern WindList:					JSR DivingBoard		/* 89 */
extern REGet1IndType:				JSR DivingBoard		/* 90 */
extern InstallColorPalettePopup:	JSR DivingBoard		/* 91 */
extern WindAlloc:					JSR DivingBoard		/* 92 */
extern REGet1NamedResource:			JSR DivingBoard		/* 93 */
extern REAddResource:				JSR DivingBoard		/* 94 */
									JSR DivingBoard		/* 95		UNUSED */
									JSR DivingBoard		/* 96		UNUSED */
extern StandardFilter:				JSR DivingBoard		/* 97 */
extern DoPopup:						JSR DivingBoard		/* 98 */

														/* Max 120 */

extern DivingBoard:
		LEA		DrawLDEF+4,A1
		MOVE.L		(SP)+,A0
		SUB.L		A1,A0
		ADD.L		ApplScratch,A0
		MOVE.L		(A0),A0
		JMP		(A0)
	}
}