/**********************************************************************\

File:		BoxOut wipe.c

Purpose:	This module handles clearing the screen in a funky
			manner.  See the comments below for more details.
			

Shutdown FX -=- graphic effects on shutdown
Copyright (C) 1993 Mark Pilgrim & Dave Blumenthal

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "msg timing.h"

#define		BOXES	50	/* increase this for a finer grained but more timely effect */
#define CorrectTime 2

void BoxOutWipe(Pattern *thePattern, int width, int height);

void BoxOutWipe(Pattern *thePattern, int width, int height)
{
	Rect			theRect;
	int				cenx, ceny;
	int				boxnum;
	int				theWindowWidth, theWindowHeight;
	
	cenx = width / 2;
	ceny = height / 2;
	
	for(boxnum = 0; boxnum <= BOXES; boxnum++)
	{
		StartTiming();
		
		/* this is not the most efficient method, but the overhead of the
		multiplies and the redundant copying is hidden by the timing mechanism */
		theRect.left = cenx - ((boxnum * cenx) / BOXES);
		theRect.right = cenx + ((boxnum * cenx) / BOXES);
		theRect.top = ceny - ((boxnum * ceny) / BOXES);
		theRect.bottom = ceny + ((boxnum * ceny) / BOXES);
		
		FillRect(&theRect, *thePattern);
		
		TimeCorrection(CorrectTime);
	}
}