/**********************************************************************\

File:		Circle serendipity.c

Purpose:	This module handles clearing the screen in a funky
			manner.  See the comments below for more details.
			

Shutdown FX -=- graphic effects on shutdown
Copyright (C) 1993 Mark Pilgrim & Dave Blumenthal

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "msg timing.h"

#define	gap			7
#define CorrectTime 2

void CircleSerendipity(Pattern *thePattern, int width, int height);

/* I haven't the slightest idea why this works.  Hence the name.  -MP */

void CircleSerendipity(Pattern *thePattern, int width, int height)
{
	Rect			theRect;
	Rect			source;
	RgnHandle		curregion;
	Point			zeropoint;
	
	source.top=source.left=0;
	source.right=width;
	source.bottom=height;
	
	theRect=source;
	theRect.top-=height;
	OffsetRect(&theRect,0,-height);
		
	curregion=NewRgn();
	SetEmptyRgn(curregion);
	OpenRgn();
		FrameOval(&theRect);
	CloseRgn(curregion);
	zeropoint.v=height;
	zeropoint.h=0;
	do
	{
		StartTiming();
		FillRgn(curregion, *thePattern);
		OffsetRgn(curregion, 0, gap);
		TimeCorrection(CorrectTime);
	}
	while (!(PtInRgn(zeropoint, curregion)));

	SetRect(&theRect, 0, 0, width, height);
	FillRect(&theRect, *thePattern);
	
	DisposeRgn(curregion);
}
