/**********************************************************************\

File:		Skipaline L-R.c

Purpose:	This module handles clearing the screen in a funky
			manner.  See the comments below for more details.
			

Shutdown FX -=- graphic effects on shutdown
Copyright (C) 1993 Mark Pilgrim & Dave Blumenthal

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "msg timing.h"

#define CorrectTime 1

void SkipalineLR(Pattern *thePattern, int width, int height);

/* Copy even-numbered columns starting at the left and moving right, and odd-
   numbered columns starting at the right and moving left.  */

/* Additional note (12/14/93): your screen must have an even # of columns for
   this to work properly */

void SkipalineLR(Pattern *thePattern, int width, int height)
{
	Rect		thisone,thatone;
	Boolean		everyOther=FALSE;
	
	thisone.left=thisone.top=thatone.top=0;
	thisone.bottom=thatone.bottom=height;
	thisone.right=1;
	thatone.right=width;
	thatone.left=width-1;
		
	while (thisone.left<width)
	{
		StartTiming();
		FillRect(&thisone, *thePattern);
		FillRect(&thatone, *thePattern);
		thisone.left+=2;      /* left column moves right by 2 */
		thisone.right+=2;
		thatone.left-=2;      /* right column moves left by 2 */
		thatone.right-=2;
		if (everyOther)
			TimeCorrection(CorrectTime);
		everyOther=!everyOther;
	}
}
