/************************************************************************
 *																		*
 *	CorkIO.H															*
 *																		*
 *																		*
 *  Written by Casper Boon, August, 1986.								*
 *																		*
 *	 1986 CorkScrew Computer Technologies.								*
 *																		*
 ************************************************************************/

#ifndef _cork_io_defs_
#define _cork_io_defs_

integer fclose(integer);
integer fflush(integer);
integer fopen(char *, char *);
integer freopen(char *, char *, integer);

integer printf(char *fmt, ...);					/* print to screen */
integer dprintf(char *fmt, ...);				/* print to debug out */
integer log_printf(char *fmt, ...);				/* print to log file */
integer fprintf(integer f, char *fmt, ...);		/* print to file */
integer sprintf(char *buf, char *fmt, ...);		/* print to string */
integer psprintf(StringPtr buf, char *fmt, ...);/* print to pascal string */

integer vprintf(char *fmt, void *arglist);					/* print to screen */
integer vfprintf(integer f, char *fmt, void *arglist);		/* print to file */
integer vsprintf(char *buf, char *fmt, void *arglist);		/* print to string */
integer vpsprintf(StringPtr buf, char *fmt, void *arglist);	/* print to pascal string */

integer scanf(char *fmt, ...);
integer fscanf(integer f, char *fmt, ...);
integer sscanf(char *buf, char *fmt, ...);
integer psscanf(StringPtr buf, char *fmt, ...);

integer vscanf(char *fmt, void *arglist);
integer vfscanf(integer f, char *fmt, void *arglist);
integer vsscanf(char *buf, char *fmt, void *arglist);
integer vpsscanf(StringPtr buf, char *fmt, void *arglist);

integer fgetc(integer f);
integer fputc(integer c, integer f);
integer getchar(void);
integer	putchar(integer c);

void SetDrawingProc(ProcPtr putProc);
void SetOnOffProcs(ProcPtr onProc, ProcPtr offProc);
void SetGettingProc(ProcPtr getProc);

integer InitDebug(StringPtr LOut);
integer InitLogFile(StringPtr LOut, integer log_dir);
integer	ClearLogFile(void);

extern integer stderr;
extern integer stdlog;
#endif
