/************************************************************************
 *																		*
 * General constants used almost everywhere								*
 *																		*
 * Created	CAB	Sat Nov 29, 1986 18:37:47								*
 *																		*
 * Modified CAB	Sept 91 :	Update to be more Sys7 compliant			*
 *																		*
 *	 1986 CorkScrew Computer Technologies.								*
 *																		*
 ************************************************************************/

#ifndef _CORK_general_defs_
#define _CORK_general_defs_


#define	NIL		0L
#define	FALSE	0
#define	TRUE	1

typedef short int			integer;
typedef long int			LongInt;
typedef unsigned short int	Word;
typedef unsigned long int	LongWord;
typedef EventRecord			*EventPtr;


typedef void (*cssProcPtr)();

#define STANDARD_WTYPE_HEADER			\
	integer				recordKind;		\
	integer				menuItem;		\
	activProcPtr		activateProc;	\
	updatProcPtr		updateProc;		\
	clickProcPtr		clickProc;		\
	keyProcPtr			keyProc;		\
	closeProcPtr		closeProc;		\
	growProcPtr			growProc;		\
	zoomProcPtr			zoomProc;		\
	menuProcPtr			menuProc;		\
	cursorProcPtr		cursorProc;		\
	idleProcPtr			idleProc;

typedef void (*activProcPtr)(WindowPtr window, Boolean activ);
typedef void (*updatProcPtr)(WindowPtr window);
typedef void (*clickProcPtr)(WindowPtr window, EventPtr event);
typedef void (*keyProcPtr)(WindowPtr window, EventPtr event);
typedef integer (*closeProcPtr)(WindowPtr window);
typedef void (*growProcPtr)(WindowPtr window, Point mouse);
typedef void (*zoomProcPtr)(WindowPtr window, Boolean in);
typedef void (*cursorProcPtr)(WindowPtr window, Point mouse, RgnHandle crsRgn);
typedef void (*idleProcPtr)(WindowPtr window);
typedef Boolean (*menuProcPtr)(WindowPtr window, LongInt menuResult);
typedef void (*hitProcPtr)(WindowPtr window, integer itemHit, EventPtr event);


typedef struct standWindow
	{
	STANDARD_WTYPE_HEADER
	} standWindow, *stdWinPtr, **stdWinHand;

typedef struct standDialog
	{
	STANDARD_WTYPE_HEADER
	hitProcPtr	hitProc;
	} standDialog, *stdDialPtr, **stdDialHand;

#endif
