/************************************************************************
 *																		*
 *	LPD.H																*
 *																		*
 *  Line Printer Daemon using TCP/IP printer protocol					*
 *																		*
 *			-------------- The main header file --------------			*
 *																		*
 *  Written by Casper Boon, August, 1992.								*
 *																		*
 *	 1992 Casper Boon.													*
 *																		*
 ************************************************************************/

#include "MacTCPCommonTypes.H"	/* for the TCP/IP errors */
#include <string.h>				/* for string comparisons */


#define DEBUGGING	(debugOn)

#define SMTP_PORT	 25
#define LPD_PORT	515

#define CR			0x0D
#define	LF			0x0A


#define ABS(i) ( (i<0)?-i:i )

#define eWrongROM	1
#define eNoMemory	2
#define	eNoConfig	3


#define rMenuBar		128

/************* Menu ID numbers and item numbers ****************/
#define	appleMenu	128	/* menu ID */
#define	mAppleBlnk	  2

#define	fileMenu	129
enum	{
		mClrLItem	= 1,
		mFileBlnk1,		/* a blank line */
		mQuitItem,
		mFileBlnk2,		/* a blank line */
		mXQuitItem
		};


#define	editMenu	130
enum	{
		mUndoItem = 1,	/* UnDo */
		mEditBlnk1,		/* a blank line */
		mCutItem,		/* Cut */
		mCopyItem,		/* Copy */
	 	mPasteItem,		/* Paste */
	 	mClearItem		/* Clear */
	} ;

#define	utilMenu	131
enum	{
		mSpulrItem = 1,	/* poke spooler */
		mPostsItem,		/* print postscript */
		mUtilBlnk1,		/* a blank line */
		mDbugItem		/* debug toggle */
	} ;



/*************** Dialog ID Numbers and item numbers *************/
#define		Cancel		1	/* Main control buttons */
#define		DoitBt		2
#define		okBtn		1
#define		cancelBtn	2
#define		defFrmItm	3

#define	AboutDLOG	128
#define		abtDefFrm	4

#define	securDLOG	129
#define		listItem	2
#define		addBtn		4
#define 	remBtn		5
#define		nameTxt		6

#define rcvFlDLOG	130
#define		barUsr		2
#define prtFlDLOG	131
#define pStatDLOG	132
#define		whyText		1
#define		spinUsr		2
#define		stusTxt		3

#define	prntrDLOG	133
#define		pnamLst		4
#define 	pNBPLst		5
#define		pnamTxt		6

#define	aliasDLOG	134
#define		aliasLst	4
#define 	alsNTxt		5
#define		bcmsTxt		6

#define noReslvALRT	256


/********* external variable declarations ************/
extern	Rect			screenRect;
extern	Boolean			stopped;
extern	Boolean			haveWaitEvnt;
extern	Boolean			inBackground;
extern	RgnHandle		cursRgn;
extern	Boolean			Quitable;
extern	Boolean			QuitRequest;
extern	Boolean			debugOn;
extern	Handle			hosts;
extern	Byte			LogFileName[];
extern	char			administrator[];
extern	char			adminsHost[];
extern	Boolean			gotAdmin;
extern	Boolean			mailing;
extern	Boolean			accounting;
extern	Boolean			noAction;
