/************************************************************************
 *																		*
 *	lpdProtos.H															*
 *																		*
 *  Line Printer Daemon using TCP/IP printer protocol					*
 *																		*
 *		-------------- prototypes header file --------------			*
 *																		*
 *  Written by Casper Boon, August, 1992.								*
 *																		*
 *	 1992 Casper Boon.													*
 *																		*
 ************************************************************************/

/* in dials.c */

integer doAbout(void);
integer HandleDEvent(EventPtr);
#define AlertUser(what)		NoteAlert(128+what, NIL)
Boolean ValidHost(LongWord hostID);

void LPD_Banner_Up(void);
void LPD_Banner_Down(void);
void LPD_Banner_PCent(LongInt done, LongInt want);
void PRT_Banner_Up(StringPtr message);
void PRT_Banner_Down(void);
void PRT_Banner_PCent(LongInt done, LongInt want, StringPtr message);
void PSTAT_Banner_Up(StringPtr message);
#define PSTAT_Banner_Down		PRT_Banner_Down
void PSTAT_Banner_Step(StringPtr message);
void CVT_Banner_Up(void);
#define CVT_Banner_Down			PRT_Banner_Down
#define CVT_Banner_PCent(d, w)		PRT_Banner_PCent(d, w, NIL)
void POPEN_Banner_Up(StringPtr name, StringPtr status);
#define POPEN_Banner_Down		PRT_Banner_Down
#define POPEN_Banner_Step		PSTAT_Banner_Step
void CONFIG_Banner_Up(void);

void Banners_Down(void);
void Banners_Back(void);


/* in Init.C */
void Initialise(void);
integer ReadConfig(void);
void ParsePrinter(char *str);
void ParseHost(char *str);
void ParseCFA(char *str);
void ParseLaser(char *str);


/* in lpd.C */
Boolean InitLPD(void);
void ClearLPDLogFile(void);


/* in main.c */

void main(void);
void WaitForEvent(integer, EventPtr);
integer MainEvents(integer);
void BeepNWait(void);
integer KillWindow(WindowPeek);
void Exit(void);
void CursorAdjust(Point aPoint, RgnHandle crsRgn);
void UpdateEvents(void);
void WaitForState(integer *state);


/* in menus.c */

void SetUpMenus(void);
void SetMenuStates(void);
void DoCommand(LongInt);
integer DoPopUpMenu(integer, integer, integer, MenuHandle);

/* in Mail.c */
void SendMail(char * who, char * host, Handle mail, integer fRef);

/* in Aliases.c */
void ResolveAlias(char * who, char *host, char *who2, char *where);
void ParseAlias(char *str);
void ParseAdmin(char *str);

/* printing.c */
void PAPDownLoad(integer xRef, Boolean postscript,
						StringPtr printer, Handle elog, integer *pstate);
void SerialPrint(integer xRef, Boolean postscript,
							StringPtr printer, Word params,
									Handle elog, integer *pstate);
StringPtr PrinterStatus(StringPtr printer);
StringPtr GetPRName(void);


/* spooler.c */
void Poke_Spooler(void);
void SendPostscriptFile(void);

/* spoolutils.c */
void SetUpSpoolDir(void);
integer GetLogDir(void);
void SendJobs(integer crefnum);
void CreateSpoolFile(char *name, char *printer);
void DeleteSpoolFile(StringPtr name);
void WriteSpoolFile(char *data, integer length);
void CloseSpoolFile(void);
void LogError(char *rbuff, Handle elog);

#ifdef TEXTPS
/* textps.c */
integer textps(StringPtr name, integer refNum);
#endif

